// Modification of Xalos's AI Recycler (Made it much simpler)
function CreateAIClient(%persistent)
{
    if(isObject(AIRecycler))
    {
        if(AIRecycler.getCount() != 0)
        {
            %cl = AIRecycler.getObject(0);
            %cl.persistent = %persistent;
            AIRecycler.remove(%cl);
            trainsdebug("AIConnection requested. Returned" SPC %cl @ ".");
            return %cl;
        }
    }
    %newAI = new AIClient() { persistent = %persistent; };
    trainsdebug("AIConnection requested." SPC %newAI SPC "has been added to the buffer.");
	return %newAI;
}

function AiClient::recycle(%this)
{
	if(!isObject(aiRecycler))
	{
		new SimSet(aiRecycler);
		missionCleanup.add(aiRecycler);
	}
    
    trainsdebug(%this SPC "was recycled.");
	aiRecycler.add(%this);
}

// ----------------------------------------

// Port's bot mount threads
deactivatePackage(BotMountThreads);
package BotMountThreads {
   function AIPlayer::mountObject(%this, %object, %slot) {
      Parent::mountObject(%this, %object, %slot);
      %thread = %this.getDataBlock().mountThread[%slot];

      if (%thread $= "") {
         %thread = "root";
      }

      %object.setActionThread(%thread);
   }
};

activatePackage(BotMountThreads);